- include_role:
    name: backups
    tasks_from: wait.yaml
  vars:
    check_only: True
- include_role:
    name: directory
    tasks_from: wait.yaml
  vars:
    check_only: True
    in_namespace: "{{ auth_namespace | default(namespace) }}"
    obj_selectors: "{{ directory_selectors | default([ 'opsperator.io/' ~ cr_kind ~ '=' ~ cr_name ]) }}"
- block:
  - include_role:
      name: prometheus
      tasks_from: check.yaml
    vars:
      check_only: True
  - block:
    - name: Sets Ara Prometheus Facts
      set_fact:
        dashboards_for_deployments:
        - deployments:
          - "{{ ara_name if (do_lemon or do_ldap)                      else False }}"
          product: apache
        - deployments:
          - "{{ ara_ms_name if (ara_db_type in [ 'mariadb', 'mysql' ]) else False }}"
          - "{{ ara_pc_name if (ara_db_type == 'percona')              else False }}"
          product: mysql
        - deployments:
          - "{{ ara_pg_name }}"
          product: postgres
        dashboards_for_namespace: "{{ namespace }}"
    when:
    - grafana_public_address | default(False)
    - grafana_public_address != 'not deployed'
  when:
  - do_exporters
  - do_status_dashboards | default(False)
- name: Sets Ara Directory Facts
  set_fact:
    ara_fqdn: "{{ (ara_force_fqdn | default(False))
                    if (ara_force_fqdn | default(False))
                    else ((directory_crd.resources[0].spec.directory_fqdn_ara | default(False))
                          if (directory_cr is defined
                              and directory_crd.resources is defined
                              and directory_crd.resources | length > 0
                              and directory_crd.resources[0].spec is defined
                              and directory_crd.resources[0].spec.directory_fqdn_ara is defined
                              and directory_crd.resources[0].spec.do_ara | default(False))
                          else ('ara.' ~ root_domain)) }}"
    do_ldap: "{{ True if (ldap_address is defined
                          and directory_crd.resources | length > 0
                          and directory_crd.resources[0].spec is defined
                          and directory_crd.resources[0].spec.do_ara | default(False))
                      else False }}"
    do_lemon: "{{ True if (lemon_manager is defined
                           and lemon_manager != 'not deployed'
                           and directory_crd.resources | length > 0
                           and directory_crd.resources[0].spec is defined
                           and directory_crd.resources[0].spec.do_ara | default(False))
                       else False }}"
- block:
  - name: Fixes Directory ARA FQDN
    async: 30
    k8s:
      definition:
        apiVersion: wopla.io/v1beta1
        kind: Directory
        metadata:
          name: "{{ directory_crd.resources[0].metadata.name }}"
          namespace: "{{ ldap_namespace }}"
        spec:
          directory_fqdn_ara: "{{ ara_fqdn }}"
    when:
    - ldap_root_domain is defined
    - ldap_root_domain != root_domain
    - directory_cr is defined
    - directory_crd.resources is defined
    - directory_crd.resources | length > 0
    - directory_crd.resources[0].spec is defined
    - (directory_crd.resources[0].spec.directory_fqdn_ara | default('ara.' ~ ldap_root_domain)) != ara_fqdn
  - block:
    - include_role:
        name: directory
        tasks_from: client-config.yaml
      vars:
        config_namespace: "{{ namespace }}"
    - include_role:
        name: directory
        tasks_from: secret-dup.yaml
      vars:
        get_keys:
        - authproxy-password
        - ara-oauth2-secret
        - directory-root
    when:
    - ldap_namespace != namespace
  - include_role:
      name: commons
      tasks_from: ssl/ca-init.yaml
    vars:
      tls_provider: "{{ directory_tls_provider }}"
    when:
    - k8s_flavor == 'kubernetes'
    - directory_tls_provider != tls_provider
  when:
  - do_ldap or do_lemon
- include_role:
    name: commons
    tasks_from: ssl/ca-init.yaml
  when:
  - k8s_flavor == 'kubernetes'
- name: "Lookups Ara {{ deployment_kind }}"
  async: 30
  changed_when: False
  failed_when: False
  k8s_info:
    api_version: "{{ deployment_apivers }}"
    kind: "{{ deployment_kind }}"
    namespace: "{{ namespace }}"
    name: "{{ ara_name }}"
  no_log: True
  poll: 5
  register: ara_dc
